
## ![wsBasic](https://files.catbox.moe/dx011p.png)

wsBasic is a simple hook-on utility for ws.

  

## **Examples:**

 - [Server](#server)
 - [On connection](#on-connection)
 - [To specific UUID](#to-specific-uuid)
 - [To specific attribute](#to-client-with-specific-attribute)
 - [Channels](#channels)

## **Server:**
```js
const WebSocket = require("ws"); /// require ws
const wss = new WebSocket.Server({ port: 8080, clientTracking: true }); /// define ws server
require("wsbasic")(wss); /// enable wsbasic
```
## **On connection:**
```js
/// gives a uuid for each client
wss.on('connection', function connection(ws) {
  console.log(ws.uuid); /// xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx
});
```
## **To specific UUID:**
```js
wss.on('connection', function connection(ws) {
  wss.sendToUUID('xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx', 'hello');
});
```
## **To client with specific attribute:**
```js
wss.on('connection', function connection(ws) {
  wss.sendToAttribute({"channel": "/"}, 'hello');
});
```
## **Channels:**
```js
wss.on('connection', function connection(ws) {
  ws.channel = "hello";
  wss.broadcast("hello", "hi"); // as you probably guessed, this will send a message to all clients in "hello"
});
```