/// require dependencies
const crypto = require("crypto");
/// define art
const art = `
[0m
              [1;32m█░[0m                [1;32m▒[0m
              [1;32m█▒[0m                [1;32m█[0m
[1m█░[0m [1m█░[0m [1m█[0m [1m▄░▀▀▀[0m [1;32m█▓▒░░░░░░░░░░░░░░░▒░░░░░░[0m
[1m█░[0m [1m█░[0m [1m█[0m [1m▀▄▄▄▄[0m [1;32m██▒▒▒▒█▀▀▀██▀▀▀▀▀[0m [1;32m█[0m [1;32m█▀▀▀▀[0m
[1m█▒░█▒░█[0m   [1m░▒█[0m [1;32m██▄▄▄█▀▀▀▀█▀▀▀▀▀█[0m [1;32m█[0m [1;32m█▄▄▄▄[0m
 [1m▀▀▀▀▀[0m  [1m▀▀▀▀▀[0m [1;32m▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀[0m
    `;

/// ---
module.exports = (wss, options = {logConnections: true}) => {
    console.log(art);
    console.log("wsBasic has been attached.");
    /// --- begin
    wss.options.clientTracking = true;

    wss.on('connection', function connection(ws) {
      ws.uuid = crypto.randomUUID();
      ws.channel = '/';
      if (options.logConnections == true) {
        console.log(`Client has connected, [1;32m{Identifier: ${ws.uuid}}`);
      };
    });
    wss.broadcast = function (channel = '/', message) {
      wss.clients.forEach(function(client) {
        if (client.channel == channel || channel == '/*') {
          client.send(message);
        };
      });
    };
    wss.sendToUUID = function (uuid = '', message) {
      wss.clients.forEach(function(client) {
        if (client.uuid == uuid) {
          client.send(message);
        };
      });
    };
    wss.sendToAttribute = function (attribute = {"channel": "/"}, message) {
      wss.clients.forEach(function(client) {
        if (client[Object.keys(attribute)[0]] == attribute[Object.keys(attribute)[0]]) {
          client.send(message);
        };
      });
    };
};